import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { de_ListStatementsCommand, se_ListStatementsCommand } from "../protocols/Aws_json1_1";
export { $Command };
export class ListStatementsCommand extends $Command
    .classBuilder()
    .ep(commonParams)
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("RedshiftData", "ListStatements", {})
    .n("RedshiftDataClient", "ListStatementsCommand")
    .f(void 0, void 0)
    .ser(se_ListStatementsCommand)
    .de(de_ListStatementsCommand)
    .build() {
}
