import { HttpRequest as __HttpRequest, HttpResponse as __HttpResponse } from "@smithy/protocol-http";
import { SerdeContext as __SerdeContext } from "@smithy/types";
import { BatchExecuteStatementCommandInput, BatchExecuteStatementCommandOutput } from "../commands/BatchExecuteStatementCommand";
import { CancelStatementCommandInput, CancelStatementCommandOutput } from "../commands/CancelStatementCommand";
import { DescribeStatementCommandInput, DescribeStatementCommandOutput } from "../commands/DescribeStatementCommand";
import { DescribeTableCommandInput, DescribeTableCommandOutput } from "../commands/DescribeTableCommand";
import { ExecuteStatementCommandInput, ExecuteStatementCommandOutput } from "../commands/ExecuteStatementCommand";
import { GetStatementResultCommandInput, GetStatementResultCommandOutput } from "../commands/GetStatementResultCommand";
import { GetStatementResultV2CommandInput, GetStatementResultV2CommandOutput } from "../commands/GetStatementResultV2Command";
import { ListDatabasesCommandInput, ListDatabasesCommandOutput } from "../commands/ListDatabasesCommand";
import { ListSchemasCommandInput, ListSchemasCommandOutput } from "../commands/ListSchemasCommand";
import { ListStatementsCommandInput, ListStatementsCommandOutput } from "../commands/ListStatementsCommand";
import { ListTablesCommandInput, ListTablesCommandOutput } from "../commands/ListTablesCommand";
/**
 * serializeAws_json1_1BatchExecuteStatementCommand
 */
export declare const se_BatchExecuteStatementCommand: (input: BatchExecuteStatementCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1CancelStatementCommand
 */
export declare const se_CancelStatementCommand: (input: CancelStatementCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DescribeStatementCommand
 */
export declare const se_DescribeStatementCommand: (input: DescribeStatementCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DescribeTableCommand
 */
export declare const se_DescribeTableCommand: (input: DescribeTableCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ExecuteStatementCommand
 */
export declare const se_ExecuteStatementCommand: (input: ExecuteStatementCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetStatementResultCommand
 */
export declare const se_GetStatementResultCommand: (input: GetStatementResultCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetStatementResultV2Command
 */
export declare const se_GetStatementResultV2Command: (input: GetStatementResultV2CommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListDatabasesCommand
 */
export declare const se_ListDatabasesCommand: (input: ListDatabasesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListSchemasCommand
 */
export declare const se_ListSchemasCommand: (input: ListSchemasCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListStatementsCommand
 */
export declare const se_ListStatementsCommand: (input: ListStatementsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListTablesCommand
 */
export declare const se_ListTablesCommand: (input: ListTablesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * deserializeAws_json1_1BatchExecuteStatementCommand
 */
export declare const de_BatchExecuteStatementCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<BatchExecuteStatementCommandOutput>;
/**
 * deserializeAws_json1_1CancelStatementCommand
 */
export declare const de_CancelStatementCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CancelStatementCommandOutput>;
/**
 * deserializeAws_json1_1DescribeStatementCommand
 */
export declare const de_DescribeStatementCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeStatementCommandOutput>;
/**
 * deserializeAws_json1_1DescribeTableCommand
 */
export declare const de_DescribeTableCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeTableCommandOutput>;
/**
 * deserializeAws_json1_1ExecuteStatementCommand
 */
export declare const de_ExecuteStatementCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ExecuteStatementCommandOutput>;
/**
 * deserializeAws_json1_1GetStatementResultCommand
 */
export declare const de_GetStatementResultCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetStatementResultCommandOutput>;
/**
 * deserializeAws_json1_1GetStatementResultV2Command
 */
export declare const de_GetStatementResultV2Command: (output: __HttpResponse, context: __SerdeContext) => Promise<GetStatementResultV2CommandOutput>;
/**
 * deserializeAws_json1_1ListDatabasesCommand
 */
export declare const de_ListDatabasesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListDatabasesCommandOutput>;
/**
 * deserializeAws_json1_1ListSchemasCommand
 */
export declare const de_ListSchemasCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListSchemasCommandOutput>;
/**
 * deserializeAws_json1_1ListStatementsCommand
 */
export declare const de_ListStatementsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListStatementsCommandOutput>;
/**
 * deserializeAws_json1_1ListTablesCommand
 */
export declare const de_ListTablesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListTablesCommandOutput>;
