import {
  AwsSdkSigV4AuthInputConfig,
  AwsSdkSigV4AuthResolvedConfig,
  AwsSdkSigV4PreviouslyResolved,
} from "@aws-sdk/core";
import {
  HandlerExecutionContext,
  HttpAuthScheme,
  HttpAuthSchemeParameters,
  HttpAuthSchemeParametersProvider,
  HttpAuthSchemeProvider,
  Provider,
} from "@smithy/types";
import { RedshiftDataClientResolvedConfig } from "../RedshiftDataClient";
export interface RedshiftDataHttpAuthSchemeParameters
  extends HttpAuthSchemeParameters {
  region?: string;
}
export interface RedshiftDataHttpAuthSchemeParametersProvider
  extends HttpAuthSchemeParametersProvider<
    RedshiftDataClientResolvedConfig,
    HandlerExecutionContext,
    RedshiftDataHttpAuthSchemeParameters,
    object
  > {}
export declare const defaultRedshiftDataHttpAuthSchemeParametersProvider: (
  config: RedshiftDataClientResolvedConfig,
  context: HandlerExecutionContext,
  input: object
) => Promise<RedshiftDataHttpAuthSchemeParameters>;
export interface RedshiftDataHttpAuthSchemeProvider
  extends HttpAuthSchemeProvider<RedshiftDataHttpAuthSchemeParameters> {}
export declare const defaultRedshiftDataHttpAuthSchemeProvider: RedshiftDataHttpAuthSchemeProvider;
export interface HttpAuthSchemeInputConfig extends AwsSdkSigV4AuthInputConfig {
  authSchemePreference?: string[] | Provider<string[]>;
  httpAuthSchemes?: HttpAuthScheme[];
  httpAuthSchemeProvider?: RedshiftDataHttpAuthSchemeProvider;
}
export interface HttpAuthSchemeResolvedConfig
  extends AwsSdkSigV4AuthResolvedConfig {
  readonly authSchemePreference: Provider<string[]>;
  readonly httpAuthSchemes: HttpAuthScheme[];
  readonly httpAuthSchemeProvider: RedshiftDataHttpAuthSchemeProvider;
}
export declare const resolveHttpAuthSchemeConfig: <T>(
  config: T & HttpAuthSchemeInputConfig & AwsSdkSigV4PreviouslyResolved
) => T & HttpAuthSchemeResolvedConfig;
